package org.silverpeas.mobile.shared.services.rest;

import static org.fusesource.restygwt.client.AbstractJsonEncoderDecoder.*;

public class ServiceResourcesManager_Generated_RestServiceProxy_ implements org.silverpeas.mobile.shared.services.rest.ServiceResourcesManager, org.fusesource.restygwt.client.RestServiceProxy {
  private org.fusesource.restygwt.client.Resource resource = null;
  
  public void setResource(org.fusesource.restygwt.client.Resource resource) {
    this.resource = resource;
  }
  public org.fusesource.restygwt.client.Resource getResource() {
    if (this.resource == null) {
      String serviceRoot = org.fusesource.restygwt.client.Defaults.getServiceRoot();
      this.resource = new org.fusesource.restygwt.client.Resource(serviceRoot).resolve("/mobile/resourcesManager");
    }
    return this.resource;
  }
  private org.fusesource.restygwt.client.Dispatcher dispatcher = null;
  
  public void setDispatcher(org.fusesource.restygwt.client.Dispatcher dispatcher) {
    this.dispatcher = dispatcher;
  }
  
  public org.fusesource.restygwt.client.Dispatcher getDispatcher() {
    return this.dispatcher;
  }
  public void checkDates(java.lang.String appId, java.lang.String startDate, java.lang.String endDate, org.fusesource.restygwt.client.TextCallback callback) {
    final java.lang.String final_appId = appId;
    final java.lang.String final_startDate = startDate;
    final java.lang.String final_endDate = endDate;
    final org.fusesource.restygwt.client.Method __method =
    getResource()
    .resolve(""+(appId== null? null : com.google.gwt.http.client.URL.encodePathSegment(appId))+"/resources/checkdates/"+(startDate== null? null : com.google.gwt.http.client.URL.encodePathSegment(startDate))+"/"+(endDate== null? null : com.google.gwt.http.client.URL.encodePathSegment(endDate))+"")
    .get();
    __method.setDispatcher(this.dispatcher);
    __method.header(org.fusesource.restygwt.client.Resource.HEADER_ACCEPT, "text/plain");
    __method.send(callback);
  }
  public void deleteReservation(java.lang.String appId, org.silverpeas.mobile.shared.dto.reservations.ReservationDTO reservation, org.fusesource.restygwt.client.MethodCallback<java.lang.Void> callback) {
    final java.lang.String final_appId = appId;
    final org.silverpeas.mobile.shared.dto.reservations.ReservationDTO final_reservation = reservation;
    final org.fusesource.restygwt.client.Method __method =
    getResource()
    .resolve(""+(appId== null? null : com.google.gwt.http.client.URL.encodePathSegment(appId))+"/reservation")
    .delete();
    __method.setDispatcher(this.dispatcher);
    __method.header(org.fusesource.restygwt.client.Resource.HEADER_ACCEPT, "application/json");
    __method.header(org.fusesource.restygwt.client.Resource.HEADER_CONTENT_TYPE, "application/json");
    __method.json(org.silverpeas.mobile.shared.dto.reservations.ReservationDTO_Generated_JsonEncoderDecoder_.INSTANCE.encode(reservation));
    try {
      __method.send(new org.fusesource.restygwt.client.AbstractRequestCallback<java.lang.Void>(__method, callback) {
        protected java.lang.Void parseResult() throws Exception {
          return (java.lang.Void) null;
        }
      });
    } catch (com.google.gwt.http.client.RequestException __e) {
      callback.onFailure(__method,__e);
    }
  }
  public void getAvailableResources(java.lang.String appId, java.lang.String startDate, java.lang.String endDate, org.fusesource.restygwt.client.MethodCallback<java.util.List<org.silverpeas.mobile.shared.dto.reservations.ResourceDTO>> callback) {
    final java.lang.String final_appId = appId;
    final java.lang.String final_startDate = startDate;
    final java.lang.String final_endDate = endDate;
    final org.fusesource.restygwt.client.Method __method =
    getResource()
    .resolve(""+(appId== null? null : com.google.gwt.http.client.URL.encodePathSegment(appId))+"/resources/available/"+(startDate== null? null : com.google.gwt.http.client.URL.encodePathSegment(startDate))+"/"+(endDate== null? null : com.google.gwt.http.client.URL.encodePathSegment(endDate))+"")
    .get();
    __method.setDispatcher(this.dispatcher);
    __method.header(org.fusesource.restygwt.client.Resource.HEADER_ACCEPT, "application/json");
    try {
      __method.send(new org.fusesource.restygwt.client.AbstractRequestCallback<java.util.List<org.silverpeas.mobile.shared.dto.reservations.ResourceDTO>>(__method, callback) {
        protected java.util.List<org.silverpeas.mobile.shared.dto.reservations.ResourceDTO> parseResult() throws Exception {
          try {
            return toList(com.google.gwt.json.client.JSONParser.parse(__method.getResponse().getText()), org.silverpeas.mobile.shared.dto.reservations.ResourceDTO_Generated_JsonEncoderDecoder_.INSTANCE);
          } catch (Throwable __e) {
            throw new org.fusesource.restygwt.client.ResponseFormatException("Response was NOT a valid JSON document", __e);
          }
        }
      });
    } catch (com.google.gwt.http.client.RequestException __e) {
      callback.onFailure(__method,__e);
    }
  }
  public void getMyReservations(java.lang.String appId, org.fusesource.restygwt.client.MethodCallback<java.util.List<org.silverpeas.mobile.shared.dto.reservations.ReservationDTO>> callback) {
    final java.lang.String final_appId = appId;
    final org.fusesource.restygwt.client.Method __method =
    getResource()
    .resolve(""+(appId== null? null : com.google.gwt.http.client.URL.encodePathSegment(appId))+"/reservations/my")
    .get();
    __method.setDispatcher(this.dispatcher);
    __method.header(org.fusesource.restygwt.client.Resource.HEADER_ACCEPT, "application/json");
    try {
      __method.send(new org.fusesource.restygwt.client.AbstractRequestCallback<java.util.List<org.silverpeas.mobile.shared.dto.reservations.ReservationDTO>>(__method, callback) {
        protected java.util.List<org.silverpeas.mobile.shared.dto.reservations.ReservationDTO> parseResult() throws Exception {
          try {
            return toList(com.google.gwt.json.client.JSONParser.parse(__method.getResponse().getText()), org.silverpeas.mobile.shared.dto.reservations.ReservationDTO_Generated_JsonEncoderDecoder_.INSTANCE);
          } catch (Throwable __e) {
            throw new org.fusesource.restygwt.client.ResponseFormatException("Response was NOT a valid JSON document", __e);
          }
        }
      });
    } catch (com.google.gwt.http.client.RequestException __e) {
      callback.onFailure(__method,__e);
    }
  }
  public void saveReservation(java.lang.String appId, org.silverpeas.mobile.shared.dto.reservations.ReservationDTO dto, org.fusesource.restygwt.client.MethodCallback<org.silverpeas.mobile.shared.dto.reservations.ReservationDTO> callback) {
    final java.lang.String final_appId = appId;
    final org.silverpeas.mobile.shared.dto.reservations.ReservationDTO final_dto = dto;
    final org.fusesource.restygwt.client.Method __method =
    getResource()
    .resolve(""+(appId== null? null : com.google.gwt.http.client.URL.encodePathSegment(appId))+"/saveReservation")
    .post();
    __method.setDispatcher(this.dispatcher);
    __method.header(org.fusesource.restygwt.client.Resource.HEADER_ACCEPT, "application/json");
    __method.header(org.fusesource.restygwt.client.Resource.HEADER_CONTENT_TYPE, "application/json");
    __method.json(org.silverpeas.mobile.shared.dto.reservations.ReservationDTO_Generated_JsonEncoderDecoder_.INSTANCE.encode(dto));
    try {
      __method.send(new org.fusesource.restygwt.client.AbstractRequestCallback<org.silverpeas.mobile.shared.dto.reservations.ReservationDTO>(__method, callback) {
        protected org.silverpeas.mobile.shared.dto.reservations.ReservationDTO parseResult() throws Exception {
          try {
            return org.silverpeas.mobile.shared.dto.reservations.ReservationDTO_Generated_JsonEncoderDecoder_.INSTANCE.decode(com.google.gwt.json.client.JSONParser.parse(__method.getResponse().getText()));
          } catch (Throwable __e) {
            throw new org.fusesource.restygwt.client.ResponseFormatException("Response was NOT a valid JSON document", __e);
          }
        }
      });
    } catch (com.google.gwt.http.client.RequestException __e) {
      callback.onFailure(__method,__e);
    }
  }
}
